syms s1 t
% Task 2
% A
G = tf( 1, ([1 4 0]) )
s = tf('s');

% B
T1 = feedback(G*5,1);
T2 = feedback(G*40,1);
T3 = feedback(G*85,1);
step(T1,'b',T2,'r',T3,'g')
grid
legend('k = 5','k = 40','k = 85')

% C
% By the look of the system we can see that its a underdamped system
zeta = -(log(30)-log(100))/sqrt(pi^2+(log(30)-log(100))^2);
% zeta is inbetween 0 and 1 = underdamped system, as we assumed.
% 4s = 2 * zeta * w0 (According to the underdamped formula)
w0 = 4/(2 * zeta);
% Also according to the formula K*w0^2
K = w0^2
T4 = feedback(G*K,1);
step(T4)

S = stepinfo(T4,'RiseTimeLimits',[0,1]);
%        RiseTime: 0.3712
%    SettlingTime: 1.9508 <---
%     SettlingMin: 0.9101
%     SettlingMax: 1.2999
%       Overshoot: 29.9948
%      Undershoot: 0
%            Peak: 1.2999
%        PeakTime: 0.5987

% D
% We use Routh-Hourwitz model to solve K, within the stable margin.
%
% s^2 + 4s + k
% s^2   4    k
% s     k    0
%
% 0 > k > 4
% The TF is stable within 0 and 4.
T5 = feedback(G*4,1);
step(T5)

S2 = stepinfo(T5,'RiseTimeLimits',[0.1,0.95]);
%        RiseTime: 2.1061  <---
%    SettlingTime: 2.9170
%     SettlingMin: 0.9507
%     SettlingMax: 0.9991
%       Overshoot: 0
%      Undershoot: 0
%            Peak: 0.9991
%        PeakTime: 4.6900

% E
K=40;
Ge = (K./(s1.*(s1+4)+K));

x1 = heaviside(t).*t;
x2 = heaviside(t).*cos(t);
 
X1 = laplace(x1,t,s1);
X2 = laplace(x2,t,s1);

y1 = ilaplace(X1.*Ge);
y2 = ilaplace(X2.*Ge);
 
figure;
hold on
fplot(abs(x1-y1))
fplot(abs(x2-y2))
